import eslintConfigTypescript from '@craftworks/eslint-config-typescript';
import ngeslint from 'angular-eslint';
import eslintPluginJest from 'eslint-plugin-jest';
// No types provided
import eslintPluginRxjsTypeLess from 'eslint-plugin-rxjs-updated';
import eslintPluginCompat from 'eslint-plugin-compat';
import eslintConfigPrettier from 'eslint-config-prettier';
import globals from 'globals';
const eslintPluginRxjs = eslintPluginRxjsTypeLess;
// TODO(-eslint-plugin-rxjs-updated): Avoid the use of eslint-plugin-rxjs-updated as it is not maintained. See https://github.com/cartant/eslint-plugin-rxjs/issues/127.
// TODO(angular-eslint@>=18.4.3): Avoid using `as Linter.Config[]`
// Splitting the flat config per requires them to be set individually
// See https://github.com/typescript-eslint/typescript-eslint/blob/main/packages/typescript-eslint/src/config-helper.ts
// Note that we only support `**/*.ts` and `**/*.html` (and not `**/*.js`)
const config = [
    ...eslintConfigTypescript.map((conf) => (Object.assign(Object.assign({}, conf), { files: ['**/*.ts'] }))),
    ...ngeslint.configs.tsRecommended.map((conf) => (Object.assign(Object.assign({}, conf), { files: ['**/*.ts'] }))),
    Object.assign(Object.assign({}, eslintPluginJest.configs['flat/recommended']), { files: ['**/*.ts'] }),
    Object.assign(Object.assign({}, eslintPluginJest.configs['flat/style']), { files: ['**/*.ts'] }),
    Object.assign(Object.assign({}, eslintPluginRxjs.configs.recommended), { plugins: { rxjs: eslintPluginRxjs }, files: ['**/*.ts'] }),
    Object.assign(Object.assign({}, eslintPluginCompat.configs['flat/recommended']), { files: ['**/*.ts'] }),
    Object.assign(Object.assign({}, eslintConfigPrettier), { files: ['**/*.ts'] }),
    {
        files: ['**/*.ts'],
        processor: ngeslint.processInlineTemplates,
        languageOptions: {
            globals: Object.assign({}, globals.browser),
        },
    },
    ...ngeslint.configs.templateRecommended.map((conf) => (Object.assign(Object.assign({}, conf), { files: ['**/*.html'] }))),
    ...ngeslint.configs.templateAccessibility.map((conf) => (Object.assign(Object.assign({}, conf), { files: ['**/*.html'] }))),
    Object.assign(Object.assign({}, eslintConfigPrettier), { files: ['**/*.html'] }),
];
export default config;
